/************************************************************************************/
/*  Program name CAPGLIMP_HIST_RATE_RANGES.sql                                      */
/*  Creater:  NIP Karen (PCCW - UniHub)                                         	*/
/*************   History   *************************                                */
/* 27 JAN, 2006   NIP Karen         First created                                   */
/************************************************************************************/
SET SERVEROUTPUT ON SIZE 1000000;

DECLARE
	lv_Prog_ID		VARCHAR2(100)	:=	'CAPGLIMP_HIST_RATE_RANGES';

	lv_Scc_Count	NUMBER	:=	0;
	lv_Err_Count	NUMBER	:=	0;
	lv_Err_Msg		VARCHAR2(500)	:=	'No Error';

	CURSOR Cur_F IS
	SELECT
		*
	FROM
		CRST_GL_HIST_RATE_RANGES;
	
	lv_Next_Seq_ID		NUMBER;
	
BEGIN
	FOR C1 IN Cur_F LOOP
		BEGIN
			SELECT	GL_HISTORICAL_RATE_RANGES_S.NextVal
			INTO	lv_Next_Seq_ID
			FROM	DUAL;

			INSERT INTO GL_HISTORICAL_RATE_RANGES
			VALUES
			(
			lv_Next_Seq_ID,
			CAPBRIMP_COMMON.GetSOBID(C1.SOB_SHORT_NAME),
			C1.TARGET_CURRENCY,
			C1.PERIOD_NAME,
			C1.LAST_UPDATE_DATE,
			CAPBRIMP_COMMON.GetUser(C1.LAST_UPDATED_NAME),
			C1.TRANSLATED_RATE,
			C1.TRANSLATED_AMOUNT,
			C1.STATUS,
			C1.CREATION_DATE,
			CAPBRIMP_COMMON.GetUser(C1.CREATED_NAME),
			C1.LAST_UPDATE_LOGIN,
			C1.SEGMENT1_LOW,
			C1.SEGMENT1_HIGH,
			C1.SEGMENT2_LOW,
			C1.SEGMENT2_HIGH,
			C1.SEGMENT3_LOW,
			C1.SEGMENT3_HIGH,
			C1.SEGMENT4_LOW,
			C1.SEGMENT4_HIGH,
			C1.SEGMENT5_LOW,
			C1.SEGMENT5_HIGH,
			C1.SEGMENT6_LOW,
			C1.SEGMENT6_HIGH,
			C1.SEGMENT7_LOW,
			C1.SEGMENT7_HIGH,
			C1.SEGMENT8_LOW,
			C1.SEGMENT8_HIGH,
			C1.SEGMENT9_LOW,
			C1.SEGMENT9_HIGH,
			C1.SEGMENT10_LOW,
			C1.SEGMENT10_HIGH,
			C1.SEGMENT11_LOW,
			C1.SEGMENT11_HIGH,
			C1.SEGMENT12_LOW,
			C1.SEGMENT12_HIGH,
			C1.SEGMENT13_LOW,
			C1.SEGMENT13_HIGH,
			C1.SEGMENT14_LOW,
			C1.SEGMENT14_HIGH,
			C1.SEGMENT15_LOW,
			C1.SEGMENT15_HIGH,
			C1.SEGMENT16_LOW,
			C1.SEGMENT16_HIGH,
			C1.SEGMENT17_LOW,
			C1.SEGMENT17_HIGH,
			C1.SEGMENT18_LOW,
			C1.SEGMENT18_HIGH,
			C1.SEGMENT19_LOW,
			C1.SEGMENT19_HIGH,
			C1.SEGMENT20_LOW,
			C1.SEGMENT20_HIGH,
			C1.SEGMENT21_LOW,
			C1.SEGMENT21_HIGH,
			C1.SEGMENT22_LOW,
			C1.SEGMENT22_HIGH,
			C1.SEGMENT23_LOW,
			C1.SEGMENT23_HIGH,
			C1.SEGMENT24_LOW,
			C1.SEGMENT24_HIGH,
			C1.SEGMENT25_LOW,
			C1.SEGMENT25_HIGH,
			C1.SEGMENT26_LOW,
			C1.SEGMENT26_HIGH,
			C1.SEGMENT27_LOW,
			C1.SEGMENT27_HIGH,
			C1.SEGMENT28_LOW,
			C1.SEGMENT28_HIGH,
			C1.SEGMENT29_LOW,
			C1.SEGMENT29_HIGH,
			C1.SEGMENT30_LOW,
			C1.SEGMENT30_HIGH
			);
		EXCEPTION
			WHEN OTHERS THEN
				DBMS_OUTPUT.Put_Line(SQLERRM);
				lv_Err_Count	:=	lv_Err_Count + 1;
		END;
		lv_Scc_Count	:=	lv_Scc_Count	+	1;
	END LOOP;
	
	IF	lv_Err_Count	>	0	THEN
		ROLLBACK;
	END IF;
	
	INSERT INTO CAPCNV_LOG(
		PROG_ID,
		PROCESS_DATE,
		RECORD_PROCESSED,
		RECORD_REJECTED,
		RECORD_EXTRACTED,
		ERR_MSG
	) VALUES (
		lv_Prog_ID,
		SYSDATE,
		lv_Scc_Count,
		lv_Err_Count,
		lv_Scc_Count-lv_Err_Count,
		lv_Err_Msg
	);
	
	COMMIT;
END;
/